From 782634a849932756657bcb6d96c5ff9dc10814ed Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Tue, 8 Jun 2021 10:07:13 +0200
Subject: [PATCH] fonts: add orkney (#54644)

---
 README                                        |   7 +++++++
 static/fonts/Orkney/orkney-bold-italic.woff   | Bin 0 -> 45656 bytes
 static/fonts/Orkney/orkney-bold-italic.woff2  | Bin 0 -> 32980 bytes
 static/fonts/Orkney/orkney-bold.woff          | Bin 0 -> 43904 bytes
 static/fonts/Orkney/orkney-bold.woff2         | Bin 0 -> 31716 bytes
 static/fonts/Orkney/orkney-light-italic.woff  | Bin 0 -> 45456 bytes
 static/fonts/Orkney/orkney-light-italic.woff2 | Bin 0 -> 32996 bytes
 static/fonts/Orkney/orkney-light.woff         | Bin 0 -> 42784 bytes
 static/fonts/Orkney/orkney-light.woff2        | Bin 0 -> 31156 bytes
 static/fonts/Orkney/orkney-medium-italic.woff | Bin 0 -> 45728 bytes
 .../fonts/Orkney/orkney-medium-italic.woff2   | Bin 0 -> 33144 bytes
 static/fonts/Orkney/orkney-medium.woff        | Bin 0 -> 43260 bytes
 static/fonts/Orkney/orkney-medium.woff2       | Bin 0 -> 31312 bytes
 .../fonts/Orkney/orkney-regular-italic.woff   | Bin 0 -> 46380 bytes
 .../fonts/Orkney/orkney-regular-italic.woff2  | Bin 0 -> 33656 bytes
 static/fonts/Orkney/orkney-regular.woff       | Bin 0 -> 44040 bytes
 static/fonts/Orkney/orkney-regular.woff2      | Bin 0 -> 31956 bytes
 static/includes/fonts/_orkney.scss            |  19 ++++++++++++++++++
 18 files changed, 26 insertions(+)
 create mode 100755 static/fonts/Orkney/orkney-bold-italic.woff
 create mode 100755 static/fonts/Orkney/orkney-bold-italic.woff2
 create mode 100755 static/fonts/Orkney/orkney-bold.woff
 create mode 100755 static/fonts/Orkney/orkney-bold.woff2
 create mode 100755 static/fonts/Orkney/orkney-light-italic.woff
 create mode 100755 static/fonts/Orkney/orkney-light-italic.woff2
 create mode 100755 static/fonts/Orkney/orkney-light.woff
 create mode 100755 static/fonts/Orkney/orkney-light.woff2
 create mode 100755 static/fonts/Orkney/orkney-medium-italic.woff
 create mode 100755 static/fonts/Orkney/orkney-medium-italic.woff2
 create mode 100755 static/fonts/Orkney/orkney-medium.woff
 create mode 100755 static/fonts/Orkney/orkney-medium.woff2
 create mode 100755 static/fonts/Orkney/orkney-regular-italic.woff
 create mode 100755 static/fonts/Orkney/orkney-regular-italic.woff2
 create mode 100755 static/fonts/Orkney/orkney-regular.woff
 create mode 100755 static/fonts/Orkney/orkney-regular.woff2
 create mode 100644 static/includes/fonts/_orkney.scss

diff --git a/README b/README
index 971f3b1f..1067fc07 100644
--- a/README
+++ b/README
@@ -321,6 +321,13 @@ copyright notices:
   # This Font Software is licensed under the SIL Open Font License, Version 1.1.
   #
   # https://github.com/cadsondemak/Krub/
+
+* Orkney
+  # Concept Sketches: Samuel Oakes, font development: Alfredo Marco Pradil
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://fontlibrary.org/en/font/orkney
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/Orkney/orkney-bold-italic.woff b/static/fonts/Orkney/orkney-bold-italic.woff
new file mode 100755
index 0000000000000000000000000000000000000000..4b5aaad52ab07f0e15992f5cbf6ccb7cc342a9f9
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-bold-italic.woff2 b/static/fonts/Orkney/orkney-bold-italic.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..b64c940c2582d573a1e394dc581d1814d69ab976
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-bold.woff b/static/fonts/Orkney/orkney-bold.woff
new file mode 100755
index 0000000000000000000000000000000000000000..b88fb198444c7f4517782076848c308e3b8b5034
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-bold.woff2 b/static/fonts/Orkney/orkney-bold.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..7622892b67ad5dd6bd51cbd66eca9562e3f0b1de
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-light-italic.woff b/static/fonts/Orkney/orkney-light-italic.woff
new file mode 100755
index 0000000000000000000000000000000000000000..bc31b7a0297596e13e9fd6b5d196fedf6c3d94ac
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-light-italic.woff2 b/static/fonts/Orkney/orkney-light-italic.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..56d0c691dcafa6736a012dec82132f423e77a979
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-light.woff b/static/fonts/Orkney/orkney-light.woff
new file mode 100755
index 0000000000000000000000000000000000000000..0e4d369e0a5dedf5c87c7864d861f9c5b693af08
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-light.woff2 b/static/fonts/Orkney/orkney-light.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..70b88610d34c8ce8a0ac55f75343e45ea6fee847
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-medium-italic.woff b/static/fonts/Orkney/orkney-medium-italic.woff
new file mode 100755
index 0000000000000000000000000000000000000000..695faad852a91269e0497475bd4bfcb3a3cbee13
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-medium-italic.woff2 b/static/fonts/Orkney/orkney-medium-italic.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..7cea43182ccf4a0f7d8ad109807933849e3e1d00
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-medium.woff b/static/fonts/Orkney/orkney-medium.woff
new file mode 100755
index 0000000000000000000000000000000000000000..bd54b9e3d16edd9e0f9fa178f0b8b94eebec14c5
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-medium.woff2 b/static/fonts/Orkney/orkney-medium.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..ae23936b91f6b3f9a9e25bd8dcf939cd2c36ad53
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-regular-italic.woff b/static/fonts/Orkney/orkney-regular-italic.woff
new file mode 100755
index 0000000000000000000000000000000000000000..8bcd75910e19764be7f4ced2245778dc636a5a6c
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-regular-italic.woff2 b/static/fonts/Orkney/orkney-regular-italic.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..344efa3242adbf220e42fe7c604040b73c2d2330
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-regular.woff b/static/fonts/Orkney/orkney-regular.woff
new file mode 100755
index 0000000000000000000000000000000000000000..79a4f71f87d5287c4a27d80e8b74c82d02f30020
GIT binary patch
diff --git a/static/fonts/Orkney/orkney-regular.woff2 b/static/fonts/Orkney/orkney-regular.woff2
new file mode 100755
index 0000000000000000000000000000000000000000..0193a19013980b9ddc4dd09f8ebc97cda39d8d14
GIT binary patch
diff --git a/static/includes/fonts/_orkney.scss b/static/includes/fonts/_orkney.scss
new file mode 100644
index 00000000..bfd490fc
--- /dev/null
+++ b/static/includes/fonts/_orkney.scss
@@ -0,0 +1,19 @@
+@mixin orkney-font($type, $weight, $style: normal) {
+    @font-face {
+        font-family: 'Orkney';
+        src: url('/static/fonts/Orkney/orkney-#{$type}.woff2') format('woff2'),
+             url('/static/fonts/Orkney/orkney-#{$type}.woff') format('woff');
+        font-weight: $weight;
+        font-style: $style;
+    }
+}
+
+@mixin orkney-font-pair($type, $weight) {
+    @include orkney-font($type, $weight);
+    @include orkney-font(#{$type}-italic, $weight, italic);
+}
+
+@include orkney-font-pair('light', 300);
+@include orkney-font-pair('regular', 400);
+@include orkney-font-pair('medium', 500);
+@include orkney-font-pair('bold', 700);
-- 
2.20.1